import QtQuick 2.0
import MuseScore 1.0
import QtQuick.Controls 1.0
import QtQuick.Layouts 1.0

MuseScore {
      version: "1.0"
      description: "This plugin will switch the visibility of the selected voice."
      menuPath: "Plugins.Visible Switch"
      pluginType: "dialog"

      width: 210
      height: 140

      onRun: { }


      function switchIt(what) {
            
            // number_of_players [chord_voice_count - 2] [visible_voice - 1] [available_note]
            // number_of_players [first array is for voicenumber-inversion]
            var two   = [
                        [ [false, true] , [true, false] ]
                        ];
            var three = [
                        [ [false, true] , [false, true] , [true, false] ],
                        [ [false, false, true] , [false, true, false] , [true, false, false] ]
                        ];
            var four  = [
                        [ [false, true] , [false, true] , [true, false] , [true, false] ],
                        [ [false, false, true] , [false, false, true] , [false, true, false] , [true, false, false] ],
                        [ [false, false, false, true] , [false, false, true, false] , [false, true, false, false] , [true, false, false, false] ],
                        ];

            var idx = 1;
            var staff = 0;
            var voices = spinbox.value;

            if (tabPositionGroup.current.text == "1st") { idx = 1; }
            else if (tabPositionGroup.current.text == "2nd") { idx = 2; }
            else if (tabPositionGroup.current.text == "3rd") { idx = 3; }
            else if (tabPositionGroup.current.text == "4th") { idx = 4; }
            console.log("User chose: " + idx);
            console.log("User wants: " + what);

            if (typeof curScore === 'undefined')
                  Qt.quit();
            var cursor = curScore.newCursor();
            cursor.rewind(1);


            // check the selection
            if (!cursor.segment) {
                  staff = 0; // choose first staff, when no selection
            } else {
                  staff = cursor.staffIdx;
            }
            console.log("Starting staff: "+ staff);


            // rewind to the beginning with either the first staff, or the one which was selected
            cursor.rewind(0);
            cursor.staffIdx = staff;


            // cycle through every notes and chords
            while (cursor.segment && cursor.tick < curScore.lastSegment.tick + 1) {
                  if (cursor.element && cursor.element.type == Element.CHORD) {

                        // it is a chord with more than 1 notes                  
                        var chord_leng = cursor.element.notes.length;
                        if (chord_leng > 1 && chord_leng <= voices) {
                              var leng = cursor.element.notes.length;
                              console.log("Found chord with number of voices: " + leng);

                              // show all / reset
                              if (what == 0) {
                                    for (var i = leng-1; i >= 0; i-- ) {
                                          cursor.element.notes[i].play    = true;
                                          cursor.element.notes[i].visible = true;
                                    }
                              }


                              // show only this voice
                              if (what == 1) {

                                    // number of players is 2
                                    if (voices == 2) {
                                          for (var i = chord_leng - 1; i >= 0; i--) {
                                                if (idx == voices-i && two[chord_leng-2][idx-1][i]) {
                                                      cursor.element.notes[i].play    = true;
                                                      cursor.element.notes[i].visible = true;
                                                } else {
                                                      cursor.element.notes[i].play    = false;
                                                      cursor.element.notes[i].visible = false;
                                                      cursor.element.stem.visible = false;
                                                }
                                          }
                                    }

                                    // number of players is 3
                                    if (voices == 3) {
                                          for (var i = chord_leng - 1; i >= 0; i--) {
                                                if (idx == voices-i && three[chord_leng-2][idx-1][i]) {
                                                      cursor.element.notes[i].play    = true;
                                                      cursor.element.notes[i].visible = true;
                                                } else {
                                                      cursor.element.notes[i].play    = false;
                                                      cursor.element.notes[i].visible = false;
                                                }
                                          }
                                    }

                                    // number of players is 4
                                    if (voices == 4) {
                                          for (var i = chord_leng - 1; i >= 0; i--) {
                                                if (idx == voices-i && four[chord_leng-2][idx-1][i]) {
                                                      cursor.element.notes[i].play    = true;
                                                      cursor.element.notes[i].visible = true;
                                                } else {
                                                      cursor.element.notes[i].play    = false;
                                                      cursor.element.notes[i].visible = false;
                                                }
                                          }
                                    }

                              }


                        }


                  }
                  cursor.next();
            }
            

            
            Qt.quit();
      }

      
      function testing () {
            var cursor = curScore.newCursor();
            cursor.rewind(0);

            // cursor.element.notes[2].visible = false;
            // cursor.element.notes[2].play = false;


            Qt.quit();
      }


      ColumnLayout {
            GroupBox {
                  title: "Choose a voice:"

                  RowLayout {
                        ExclusiveGroup { id: tabPositionGroup }
                        RadioButton {
                              text: "1st"
                              checked: true
                              exclusiveGroup: tabPositionGroup
                        }
                        RadioButton {
                              text: "2nd"
                              exclusiveGroup: tabPositionGroup
                        }
                        RadioButton {
                              text: "3rd"
                              exclusiveGroup: tabPositionGroup
                        }
                        RadioButton {
                              text: "4th"
                              exclusiveGroup: tabPositionGroup
                        }
                  }
            }

            RowLayout {

                  Text {
                        text: "How much players?"
                  }

                  SpinBox {
                        id: spinbox
                        minimumValue: 2
                        maximumValue: 4
                        stepSize:     1
                        Layout.fillWidth: true
                        Layout.preferredHeight: 25
                        value: 4
                  }
            }
            
            Button {
                  text: "Show ONLY this voice"
                  Layout.fillWidth: true
                  onClicked: { switchIt(1); }
            }

            Button {
                  text: "Show all / reset"
                  Layout.fillWidth: true
                  onClicked: { switchIt(0); }
            }

      }

}